CIPDataSmiles
Date: 2019-10-22

org.jmol.symmetry

## Class CIPDataSmiles

- java.lang.Object
- - org.jmol.symmetry.CIPData
  - - org.jmol.symmetry.CIPDataSmiles

-     public class CIPDataSmiles
      extends CIPData

  A subclass that allows Jmol processing of SMILES using "...smiles...".find("SMILES","chirality")

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private Node[]` | `nodes`
    `(package private) java.lang.String` | `smiles`

    - ### Fields inherited from class org.jmol.symmetry.CIPData

      `atoms, bsAromatic, bsAtoms, bsAtropisomeric, bsAzacyclic, bsEnes, bsHelixM, bsHelixP, bsKekuleAmbiguous, bsMolecule, bsNegativeAromatic, bsXAromatic, lstSmallRings, testRule6Full, TRIGONALITY_MIN, vNorm, vTemp, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CIPDataSmiles()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private SmilesAtom` | `findCumulativeCenter(CIPChirality.CIPAtom a, CIPChirality.CIPAtom a2)`
    `(package private) int` | `getBondOrder(SimpleEdge bond)`
    `protected javajs.util.BS[]` | `getList(java.lang.String smarts)` Retrieve an array of bit sets that match a given SMARTS
    `java.lang.String[]` | `getSmilesChiralityArray()`
    `private int` | `getStereoEdge(SimpleNode atom, SimpleNode winner)`
    `(package private) int` | `isCis(CIPChirality.CIPAtom a, CIPChirality.CIPAtom b, CIPChirality.CIPAtom c, CIPChirality.CIPAtom d)` Check cis vs.
    `(package private) int` | `isPositiveTorsion(CIPChirality.CIPAtom a, CIPChirality.CIPAtom b, CIPChirality.CIPAtom c, CIPChirality.CIPAtom d)` Checks the torsion angle and returns true if it is positive
    `(package private) boolean` | `isSmiles()` Subclass identifier
    `protected javajs.util.BS` | `match(java.lang.String smarts)` Return a bit set corresponding to a SMARTS
    `CIPDataSmiles` | `setAtomsForSmiles(Viewer vwr, java.lang.String smiles)`
    `(package private) boolean` | `setCoord(SimpleNode atom, CIPChirality.CIPAtom[] atoms)` set the coordinate -- SMILES only

    - ### Methods inherited from class org.jmol.symmetry.CIPData

      `checkHandedness, couldBeChiralAlkene, couldBeChiralAtom, getEneKekule, getRootTrackerResult, getTrigonality, init, isTracker, set, setRule6Full, track`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### smiles

          java.lang.String smiles

    - #### nodes

          private Node[] nodes

  - ### Constructor Detail

    - #### CIPDataSmiles

          public CIPDataSmiles()

  - ### Method Detail

    - #### isSmiles

          boolean isSmiles()

      Description copied from class: `CIPData`
      Subclass identifier
      Overrides:
        `isSmiles` in class `CIPData`
      Returns:
        true for CIPDataSmiles

    - #### setAtomsForSmiles

          public CIPDataSmiles setAtomsForSmiles(Viewer vwr,
                                                 java.lang.String smiles)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getList

          protected javajs.util.BS[] getList(java.lang.String smarts)
                                      throws java.lang.Exception

      Description copied from class: `CIPData`
      Retrieve an array of bit sets that match a given SMARTS
      Overrides:
        `getList` in class `CIPData`
      Returns:
        array of matching bit sets
      Throws:
        `java.lang.Exception`

    - #### match

          protected javajs.util.BS match(java.lang.String smarts)
                                  throws java.lang.Exception

      Description copied from class: `CIPData`
      Return a bit set corresponding to a SMARTS
      Overrides:
        `match` in class `CIPData`
      Returns:
        bit set matching this SMARTS
      Throws:
        `java.lang.Exception`

    - #### getBondOrder

          int getBondOrder(SimpleEdge bond)

      Overrides:
        `getBondOrder` in class `CIPData`

    - #### isCis

          int isCis(CIPChirality.CIPAtom a,
                    CIPChirality.CIPAtom b,
                    CIPChirality.CIPAtom c,
                    CIPChirality.CIPAtom d)

      Check cis vs. trans nature of a--b==c--d.
      Overrides:
        `isCis` in class `CIPData`
      Parameters:
        `a` -
        `b` -
        `c` -
        `d` -
      Returns:
        true if this is a cis relationship

    - #### getStereoEdge

          private int getStereoEdge(SimpleNode atom,
                                    SimpleNode winner)

    - #### isPositiveTorsion

          int isPositiveTorsion(CIPChirality.CIPAtom a,
                                CIPChirality.CIPAtom b,
                                CIPChirality.CIPAtom c,
                                CIPChirality.CIPAtom d)

      Checks the torsion angle and returns true if it is positive
      Overrides:
        `isPositiveTorsion` in class `CIPData`
      Parameters:
        `a` -
        `b` -
        `c` -
        `d` -
      Returns:
        true if torsion angle is

    - #### findCumulativeCenter

          private SmilesAtom findCumulativeCenter(CIPChirality.CIPAtom a,
                                                  CIPChirality.CIPAtom a2)

    - #### setCoord

          boolean setCoord(SimpleNode atom,
                           CIPChirality.CIPAtom[] atoms)

      Description copied from class: `CIPData`
      set the coordinate -- SMILES only
      Overrides:
        `setCoord` in class `CIPData`
      Returns:
        true if coordinate is able to be set

    - #### getSmilesChiralityArray

          public java.lang.String[] getSmilesChiralityArray()